=== debian/changelog ===
quadrilateralcowboy (0~20251020.git50f5a30bd-1) unstable; urgency=medium

  [ James Addison ]
  * Initial release. Closes: #1026277

 -- James Addison <jay@jp-hosting.net>  Mon, 20 Oct 2025 11:52:23 +0100
