=== debian/control ===
Source: quadrilateralcowboy
Section: contrib/games
Priority: optional
Maintainer: James Addison <jay@jp-hosting.net>
Build-Depends:
 debhelper-compat (= 13),
 cmake,
 m4,
 libjpeg62-turbo-dev,
 libopenal-dev,
 libsdl2-dev,
 libvorbis-dev,
Standards-Version: 4.7.0
Homepage: https://www.blendogames.com/qc/
Vcs-Browser: https://salsa.debian.org/jayaddison/quadrilateralcowboy/
Vcs-Git: https://salsa.debian.org/jayaddison/quadrilateralcowboy.git/
Rules-Requires-Root: no

Package: quadrilateralcowboy
Architecture: i386 amd64
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
 quadrilateralcowboy-data | game-data-packager,
Description: first-person cyberpunk adventure game
 Quadrilateral Cowboy is self-described as "a first-person hacking adventure in
 a cyberpunk world".
 .
 The game features elements of programming, automation and puzzle-solving in a
 variety of 3D environments.
 .
 Data files for the game are not included in this package and can be purchased
 from the game's website at https://www.blendogames.com/qc/
