## quadrilateralcowboy 0~20251124.gitcc4b1cd45+dfsg

=== CMakeLists.txt ===
--- 
+++ 
@@ -59,8 +59,79 @@
 	SET(CMAKE_INSTALL_RPATH_USE_LINK_PATH FALSE)
 ENDIF()
 
+# Include Directories
+INCLUDE_DIRECTORIES(. sound/OggVorbis/vorbissrc/)
+
 # Source Lists
 SET(QC_SRC
+	renderer/jpeg-6/jcapimin.c
+	renderer/jpeg-6/jccoefct.c
+	renderer/jpeg-6/jccolor.c
+	renderer/jpeg-6/jcdctmgr.c
+	renderer/jpeg-6/jchuff.c
+	renderer/jpeg-6/jcinit.c
+	renderer/jpeg-6/jcmainct.c
+	renderer/jpeg-6/jcmarker.c
+	renderer/jpeg-6/jcmaster.c
+	renderer/jpeg-6/jcomapi.c
+	renderer/jpeg-6/jcparam.c
+	renderer/jpeg-6/jcphuff.c
+	renderer/jpeg-6/jcprepct.c
+	renderer/jpeg-6/jcsample.c
+	renderer/jpeg-6/jdapimin.c
+	renderer/jpeg-6/jdapistd.c
+	renderer/jpeg-6/jdatadst.c
+	renderer/jpeg-6/jdatasrc.c
+	renderer/jpeg-6/jdcoefct.c
+	renderer/jpeg-6/jdcolor.c
+	renderer/jpeg-6/jddctmgr.c
+	renderer/jpeg-6/jdhuff.c
+	renderer/jpeg-6/jdinput.c
+	renderer/jpeg-6/jdmainct.c
+	renderer/jpeg-6/jdmarker.c
+	renderer/jpeg-6/jdmaster.c
+	renderer/jpeg-6/jdmerge.c
+	renderer/jpeg-6/jdphuff.c
+	renderer/jpeg-6/jdpostct.c
+	renderer/jpeg-6/jdsample.c
+	renderer/jpeg-6/jdtrans.c
+	renderer/jpeg-6/jerror.c
+	renderer/jpeg-6/jfdctflt.c
+	renderer/jpeg-6/jfdctfst.c
+	renderer/jpeg-6/jfdctint.c
+	renderer/jpeg-6/jidctflt.c
+	renderer/jpeg-6/jidctfst.c
+	renderer/jpeg-6/jidctint.c
+	renderer/jpeg-6/jidctred.c
+	renderer/jpeg-6/jmemmgr.c
+	renderer/jpeg-6/jmemnobs.c
+	renderer/jpeg-6/jquant1.c
+	renderer/jpeg-6/jquant2.c
+	renderer/jpeg-6/jutils.c
+	sound/OggVorbis/oggsrc/bitwise.c
+	sound/OggVorbis/oggsrc/framing.c
+	sound/OggVorbis/vorbissrc/analysis.c
+	sound/OggVorbis/vorbissrc/bitrate.c
+	sound/OggVorbis/vorbissrc/block.c
+	sound/OggVorbis/vorbissrc/codebook.c
+	sound/OggVorbis/vorbissrc/envelope.c
+	sound/OggVorbis/vorbissrc/floor0.c
+	sound/OggVorbis/vorbissrc/floor1.c
+	sound/OggVorbis/vorbissrc/info.c
+	sound/OggVorbis/vorbissrc/lookup.c
+	sound/OggVorbis/vorbissrc/lpc.c
+	sound/OggVorbis/vorbissrc/lsp.c
+	sound/OggVorbis/vorbissrc/mapping0.c
+	sound/OggVorbis/vorbissrc/mdct.c
+	sound/OggVorbis/vorbissrc/psy.c
+	sound/OggVorbis/vorbissrc/registry.c
+	sound/OggVorbis/vorbissrc/res0.c
+	sound/OggVorbis/vorbissrc/sharedbook.c
+	sound/OggVorbis/vorbissrc/smallft.c
+	sound/OggVorbis/vorbissrc/synthesis.c
+	sound/OggVorbis/vorbissrc/vorbisenc.c
+	sound/OggVorbis/vorbissrc/vorbisfile.c
+	sound/OggVorbis/vorbissrc/windowvb.c
 	renderer/Cinematic.cpp
 	renderer/GuiModel.cpp
 	renderer/Image_files.cpp
@@ -399,76 +470,3 @@
 		sys/posix/posix_main.cpp
 		sys/posix/posix_input.cpp
 		sys/posix/posix_signal.cpp
-		sys/posix/posix_threads.cpp
-		sys/linux/stack.cpp
-	)
-
-	IF(APPLE)
-		SET(QC_SRC
-			${QC_SRC}
-			sys/osx/DOOMController.mm
-			sys/osx/macosx_event.mm
-			sys/osx/macosx_glimp.mm
-			sys/osx/macosx_guids.cpp
-			sys/osx/macosx_misc.mm
-			sys/osx/macosx_sound.cpp
-			sys/osx/PickMonitor.cpp
-			sys/osx/PreferencesDialog.cpp
-		)
-	ELSE()
-		SET(QC_SRC
-			${QC_SRC}
-			idlib/bv/Frustum_gcc.cpp
-			sys/linux/sound_oal.cpp
-			sys/linux/input.cpp
-			sys/linux/glimp.cpp
-			sys/linux/glimp_dlopen.cpp
-			sys/linux/main.cpp
-		)
-	ENDIF()
-ENDIF()
-
-# Executable information
-SET(CMAKE_WIN32_EXECUTABLE ON)
-ADD_EXECUTABLE(qc ${QC_SRC})
-
-set_target_properties(qc PROPERTIES
-    CXX_STANDARD 11
-    CXX_STANDARD_REQUIRED ON)
-
-# SDL2 Dependency (Detection pulled from FAudio)
-if(WIN32)
-	set(SDL2_INCLUDE_DIRS ${CMAKE_SOURCE_DIR}/sdl2/include)
-	set(SDL2_LIBRARIES ${CMAKE_SOURCE_DIR}/sdl2/lib/win32/SDL2.lib)
-elseif(APPLE)
-	set(SDL2_INCLUDE_DIRS ${CMAKE_SOURCE_DIR}/sdl2/include)
-	set(SDL2_LIBRARIES ${CMAKE_SOURCE_DIR}/sdl2/lib/osx/libSDL2-2.0.0.dylib)
-endif()
-if (DEFINED SDL2_INCLUDE_DIRS AND DEFINED SDL2_LIBRARIES)
-	message(STATUS "using pre-defined SDL2 variables SDL2_INCLUDE_DIRS and SDL2_LIBRARIES")
-	target_include_directories(qc PUBLIC "$<BUILD_INTERFACE:${SDL2_INCLUDE_DIRS}>")
-	target_link_libraries(qc PUBLIC ${SDL2_LIBRARIES})
-else()
-	# Only try to autodetect if both SDL2 variables aren't explicitly set
-	find_package(SDL2 CONFIG)
-	if (TARGET SDL2::SDL2)
-		message(STATUS "using TARGET SDL2::SDL2")
-		target_link_libraries(qc PUBLIC SDL2::SDL2)
-	elseif (TARGET SDL2)
-		message(STATUS "using TARGET SDL2")
-		target_link_libraries(qc PUBLIC SDL2)
-	else()
-		message(STATUS "no TARGET SDL2::SDL2, or SDL2, using variables")
-		target_include_directories(qc PUBLIC "$<BUILD_INTERFACE:${SDL2_INCLUDE_DIRS}>")
-		target_link_libraries(qc PUBLIC ${SDL2_LIBRARIES})
-	endif()
-endif()
-
-# Other Dependencies
-IF(APPLE)
-	FIND_LIBRARY(OPENGL NAMES OpenGL)
-	FIND_LIBRARY(OPENAL NAMES OpenAL)
-	FIND_LIBRARY(COCOA NAMES Cocoa)
-	FIND_LIBRARY(IOKIT NAMES IOKit)
-	FIND_LIBRARY(COREAUDIO NAMES CoreAudio)
-	TARGET_LINK_LIBRARIES(qc PUBLIC objc ${OPENGL} ${OPENAL} ${COCOA} ${IOKIT} ${COREAUDIO})
