=== debian/changelog ===
quadrilateralcowboy (0~20251124.gitcc4b1cd45+dfsg-1) unstable; urgency=medium

  [ James Addison ]
  * Initial release. Closes: #1026277

 -- James Addison <jay@jp-hosting.net>  Mon, 24 Nov 2025 11:04:06 +0000
