=== debian/control ===
--- 
+++ 
@@ -14,7 +14,6 @@
 Homepage: https://www.blendogames.com/qc/
 Vcs-Browser: https://salsa.debian.org/jayaddison/quadrilateralcowboy/
 Vcs-Git: https://salsa.debian.org/jayaddison/quadrilateralcowboy.git/
-Rules-Requires-Root: no
 
 Package: quadrilateralcowboy
 Architecture: i386 amd64
