=== debian/rules ===
#!/usr/bin/make -f
export DEB_BUILD_MAINT_OPTIONS = hardening=+all

%:
	dh $@

# Generate glimp C code and header files
execute_before_dh_auto_configure:
	./flibitGLIMP.sh

# Compress the manual for distribution with the package
execute_after_dh_auto_build:
	gzip --keep ./qc.6

# Cleanup to allow package rebuilds
execute_after_dh_auto_clean:
	rm -f ./qc.6.gz
	rm -f ./sys/linux/glimp_dlopen.cpp
	rm -f ./sys/linux/glimp_local.h
