=== debian/watch ===
# Quadrilateral Cowboy's source code is published at:
#
# https://github.com/BlendoGames/quadrilateralcowboy.git/
#
# At the time of writing, it doesn't include any release tags or versioning
# information that uscan could use to meaningfully identify release-ready
# updated versions.
